summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorLuke Dashjr <luke-jr+git@utopios.org>2020-06-16 22:35:54 +0000
committerCraig Andrews <candrews@gentoo.org>2020-06-16 21:52:05 -0400
commit95f32faac99bf9db94af83aa7c3959e28782f203 (patch)
tree1e444219026cdf847842d9528a038621852866e9
parentnet-p2p/bitcoin-qt: Bump to 0.20.0 (diff)
downloadgentoo-95f32faac99bf9db94af83aa7c3959e28782f203.tar.gz
gentoo-95f32faac99bf9db94af83aa7c3959e28782f203.tar.bz2
gentoo-95f32faac99bf9db94af83aa7c3959e28782f203.zip
net-p2p/bitcoind: Bump to 0.20.0
Signed-off-by: Luke Dashjr <luke-jr+git@utopios.org> Signed-off-by: Craig Andrews <candrews@gentoo.org>
-rw-r--r--net-p2p/bitcoind/Manifest2
-rw-r--r--net-p2p/bitcoind/bitcoind-0.20.0.ebuild171
2 files changed, 173 insertions, 0 deletions
diff --git a/net-p2p/bitcoind/Manifest b/net-p2p/bitcoind/Manifest
index 39611134f05..ffd60cbe421 100644
--- a/net-p2p/bitcoind/Manifest
+++ b/net-p2p/bitcoind/Manifest
@@ -1,4 +1,6 @@
DIST bitcoin-0.16.3.knots20180918.patches.tar.xz 466344 BLAKE2B c45b96513e4b6317e6a2a55cc3b47302fbe56fb87717ae0197010694013331b5d071b85a11a73c76f08f39e9f0294d3475e89ee63272047df83893de4dbaa390 SHA512 2c3540acc668aeef4b8f01774219736d95395201ddeaccaf70e0bad4a89f05cdd5ffaf630bae0577656efb3580fae92ce0ee4bb1a720ea757ca59e3fd66e1893
DIST bitcoin-0.19.1.knots20200304.patches.tar.xz 399864 BLAKE2B de5591072b62c65c8a0fdcee7a7ed4b74d13614e47b679a05f272207b9ca0a09d476aa8ecb66321f39953a320f4d47f7d2aa62848192d493de02525c3d5abdfa SHA512 3b08023f0788535dc5943e47a595da5637172263ac8c2ad97d42c0707da7468a9843efbf90a2eb6ac99db65e362e99cbe9209ab64785c79de908e20801ba4fe5
+DIST bitcoin-0.20.0.knots20200614.patches.tar.xz 392356 BLAKE2B 17c5d5c89e279c870492ac4f98cfde6545fa3c4b5169f42c020e45ca14c133673e271b248e90286ae875aaef6b031e578d14554777a89dca5366aa4bda079012 SHA512 208234b2e7fa46e19da9954dab9828993aa62a7623d85de8e7d43ffd4b367c5e8641e82154357526a11b95c0426ec16039d2910dbbe9187daba9d14a3b2fda92
DIST bitcoin-v0.16.3.tar.gz 6658712 BLAKE2B 2c20b32ea30aed264115d1bd336b62fa28de69cbf116385508718efd7ff22537c3bd402c0965e0f6ddd8e79fc8b51f388f52f885847d36207a24523e927ca63e SHA512 2da25f56fe9b1f5a81815c14e70ff1a69ec15f742424e2c24d71303a71d57c8050dea5d5ba57425bbe0a01a3995ad9b30f0beea5dbafd1632a627cd3fd9a984d
DIST bitcoin-v0.19.1.tar.gz 6660702 BLAKE2B 93ed83f663a833f6be40195ddaf62a8ef9fcd86c3f983fe0cf1e75eaf9ae54cdc88fcdfc36d798842f29636dc8037af5b67e82643c90a6c276fa504ed022f863 SHA512 bc1afad7de5b43042d24780b07e3faf73dda69af9ef0c75fa1a32bd25b0b37e315955614ffbb2864fe827b77b63446fd88cae22da3d0706ff73df495a519ba5d
+DIST bitcoin-v0.20.0.tar.gz 6984988 BLAKE2B 2c189826b7171276df62fb8cbf713d8b4cb4307de413247f2951950ec173d069930447d7d420d1c73ba0abc97fd613a05fc527bcc796e5e2d2f3dfb57fb29b80 SHA512 7628efb70bf51e4165605d9e77f6119b855994e99d8cb6653dfbd89628304862f3a98cfe352aa8b435913000e74d297565d8a7e3f22a23006d1779b70d04a8cd
diff --git a/net-p2p/bitcoind/bitcoind-0.20.0.ebuild b/net-p2p/bitcoind/bitcoind-0.20.0.ebuild
new file mode 100644
index 00000000000..f7e6db7b7e8
--- /dev/null
+++ b/net-p2p/bitcoind/bitcoind-0.20.0.ebuild
@@ -0,0 +1,171 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+DB_VER="4.8"
+inherit autotools bash-completion-r1 db-use systemd
+
+BITCOINCORE_COMMITHASH="a62f0ed64f8bbbdfe6467ac5ce92ef5b5222d1bd"
+KNOTS_PV="${PV}.knots20200614"
+KNOTS_P="bitcoin-${KNOTS_PV}"
+
+DESCRIPTION="Original Bitcoin crypto-currency wallet for automated services"
+HOMEPAGE="https://bitcoincore.org/ https://bitcoinknots.org/"
+SRC_URI="
+ https://github.com/bitcoin/bitcoin/archive/${BITCOINCORE_COMMITHASH}.tar.gz -> bitcoin-v${PV}.tar.gz
+ https://bitcoinknots.org/files/0.20.x/${KNOTS_PV}/${KNOTS_P}.patches.txz -> ${KNOTS_P}.patches.tar.xz
+"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~mips ~ppc ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="+asm examples knots libressl +system-leveldb test upnp +wallet zeromq"
+RESTRICT="!test? ( test )"
+
+DEPEND="
+ acct-group/bitcoin
+ acct-user/bitcoin
+ >=dev-libs/boost-1.52.0:=[threads(+)]
+ dev-libs/libevent:=
+ >dev-libs/libsecp256k1-0.1_pre20170321:=[recovery]
+ >=dev-libs/univalue-1.0.4:=
+ system-leveldb? ( virtual/bitcoin-leveldb )
+ !libressl? ( dev-libs/openssl:0=[-bindist] )
+ libressl? ( dev-libs/libressl:0= )
+ upnp? ( >=net-libs/miniupnpc-1.9.20150916:= )
+ wallet? ( sys-libs/db:$(db_ver_to_slot "${DB_VER}")=[cxx] )
+ zeromq? ( net-libs/zeromq:= )
+"
+RDEPEND="${DEPEND}"
+BDEPEND="
+ >=sys-devel/autoconf-2.69
+ >=sys-devel/automake-1.13
+"
+
+DOCS=(
+ doc/bips.md
+ doc/bitcoin-conf.md
+ doc/descriptors.md
+ doc/files.md
+ doc/JSON-RPC-interface.md
+ doc/psbt.md
+ doc/reduce-traffic.md
+ doc/release-notes.md
+ doc/REST-interface.md
+ doc/tor.md
+)
+
+S="${WORKDIR}/bitcoin-${BITCOINCORE_COMMITHASH}"
+
+pkg_pretend() {
+ if use knots; then
+ elog "You are building ${PN} from Bitcoin Knots."
+ elog "For more information, see:"
+ elog "https://bitcoinknots.org/files/0.20.x/${KNOTS_PV}/${KNOTS_P}.desc.html"
+ else
+ elog "You are building ${PN} from Bitcoin Core."
+ elog "For more information, see:"
+ elog "https://bitcoincore.org/en/2020/06/03/release-${PV}/"
+ fi
+ elog "Replace By Fee policy is now always enabled by default: Your node will"
+ elog "preferentially mine and relay transactions paying the highest fee, regardless"
+ elog "of receive order. To disable RBF, set mempoolreplacement=never in bitcoin.conf"
+}
+
+src_prepare() {
+ sed -i 's/^\(complete -F _bitcoind bitcoind\) bitcoin-qt$/\1/' contrib/${PN}.bash-completion || die
+
+ local knots_patchdir="${WORKDIR}/${KNOTS_P}.patches/"
+
+ eapply "${knots_patchdir}/${KNOTS_P}.syslibs.patch"
+
+ if use knots; then
+ eapply "${knots_patchdir}/${KNOTS_P}.f.patch"
+ eapply "${knots_patchdir}/${KNOTS_P}.branding.patch"
+ eapply "${knots_patchdir}/${KNOTS_P}.ts.patch"
+ fi
+
+ default
+
+ echo '#!/bin/true' >share/genbuild.sh || die
+ mkdir -p src/obj || die
+ echo "#define BUILD_SUFFIX gentoo${PVR#${PV}}" >src/obj/build.h || die
+
+ eautoreconf
+ rm -r src/secp256k1 || die
+ if use system-leveldb; then
+ rm -r src/leveldb || die
+ fi
+}
+
+src_configure() {
+ local my_econf=(
+ $(use_enable asm)
+ --without-qtdbus
+ --without-qrencode
+ $(use_with upnp miniupnpc)
+ $(use_enable upnp upnp-default)
+ $(use_enable test tests)
+ $(use_enable wallet)
+ $(use_enable zeromq zmq)
+ --with-daemon
+ --disable-util-cli
+ --disable-util-tx
+ --disable-util-wallet
+ --disable-bench
+ --without-libs
+ --without-gui
+ --disable-fuzz
+ --disable-ccache
+ --disable-static
+ $(use_with system-leveldb)
+ --with-system-libsecp256k1
+ --with-system-univalue
+ )
+ econf "${my_econf[@]}"
+}
+
+src_install() {
+ default
+
+ rm -f "${ED}/usr/bin/test_bitcoin" || die
+
+ insinto /etc/bitcoin
+ newins "${FILESDIR}/bitcoin.conf" bitcoin.conf
+ fowners bitcoin:bitcoin /etc/bitcoin/bitcoin.conf
+ fperms 600 /etc/bitcoin/bitcoin.conf
+
+ newconfd "contrib/init/bitcoind.openrcconf" ${PN}
+ newinitd "contrib/init/bitcoind.openrc" ${PN}
+ systemd_newunit "contrib/init/bitcoind.service" "bitcoind.service"
+
+ keepdir /var/lib/bitcoin/.bitcoin
+ fperms 700 /var/lib/bitcoin
+ fowners bitcoin:bitcoin /var/lib/bitcoin/
+ fowners bitcoin:bitcoin /var/lib/bitcoin/.bitcoin
+ dosym ../../../../etc/bitcoin/bitcoin.conf /var/lib/bitcoin/.bitcoin/bitcoin.conf
+
+ doman "${FILESDIR}/bitcoin.conf.5"
+
+ use zeromq && dodoc doc/zmq.md
+
+ newbashcomp contrib/${PN}.bash-completion ${PN}
+
+ if use examples; then
+ docinto examples
+ dodoc -r contrib/{linearize,qos}
+ use zeromq && dodoc -r contrib/zmq
+ fi
+
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}/bitcoind.logrotate-r1" bitcoind
+}
+
+pkg_postinst() {
+ elog "To have ${PN} automatically use Tor when it's running, be sure your"
+ elog "'torrc' config file has 'ControlPort' and 'CookieAuthentication' setup"
+ elog "correctly, and:"
+ elog "- Using an init script: add the 'bitcoin' user to the 'tor' user group."
+ elog "- Running bitcoind directly: add that user to the 'tor' user group."
+}